Mapper (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types, class: Mapper

# Class Mapper

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Mapper

All Implemented Interfaces:
  `Cloneable`

public class Mapper extends DataType
Element to define a FileNameMapper.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Mapper.MapperType`
  Class as Argument to FileNameMapper.setType.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `classname`
  `protected Path`
  `classpath`
  `protected String`
  `from`
  `protected String`
  `to`
  `protected Mapper.MapperType`
  `type`

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Mapper(Project p)`
  Construct a new `Mapper` element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(FileNameMapper fileNameMapper)`
  Add a nested `FileNameMapper`.
  `void`
  `addConfigured(FileNameMapper fileNameMapper)`
  Cannot mix add and addconfigured in same type, so provide this to override the add method.
  `void`
  `addConfiguredMapper(Mapper mapper)`
  Add a Mapper
  `Path`
  `createClasspath()`
  Set the classpath to load the FileNameMapper through (nested element).
  `FileNameMapper`
  `getImplementation()`
  Returns a fully configured FileNameMapper implementation.
  `protected Class<? extends FileNameMapper>`
  `getImplementationClass()`
  Gets the Class object associated with the mapper implementation.
  `protected Mapper`
  `getRef()`
  Deprecated.
  since Ant 1.7.1 because a mapper might ref a FileNameMapper implementation directly.
  `void`
  `setClassname(String classname)`
  Set the class name of the FileNameMapper to use.
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to load the FileNameMapper through (attribute).
  `void`
  `setClasspathRef(Reference ref)`
  Set the classpath to load the FileNameMapper through via reference (attribute).
  `void`
  `setFrom(String from)`
  Set the argument to FileNameMapper.setFrom
  `void`
  `setRefid(Reference r)`
  Make this Mapper instance a reference to another Mapper.
  `void`
  `setTo(String to)`
  Set the argument to FileNameMapper.setTo
  `void`
  `setType(Mapper.MapperType type)`
  Set the type of `FileNameMapper` to use.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### type

    protected Mapper.MapperType type

  - ### classname

    protected String classname

  - ### classpath

    protected Path classpath

  - ### from

    protected String from

  - ### to

    protected String to

- ## Constructor Details

  - ### Mapper

    public Mapper(Project p)
    Construct a new `Mapper` element.
    Parameters:
      `p` - the owning Ant `Project`.

- ## Method Details

  - ### setType

    public void setType(Mapper.MapperType type)
    Set the type of `FileNameMapper` to use.
    Parameters:
      `type` - the `MapperType` enumerated attribute.

  - ### addConfigured

    public void addConfigured(FileNameMapper fileNameMapper)
    Cannot mix add and addconfigured in same type, so provide this to override the add method.
    Parameters:
      `fileNameMapper` - the `FileNameMapper` to add.

  - ### add

    public void add(FileNameMapper fileNameMapper)
    Add a nested `FileNameMapper`.
    Parameters:
      `fileNameMapper` - the `FileNameMapper` to add.

  - ### addConfiguredMapper

    public void addConfiguredMapper(Mapper mapper)
    Add a Mapper
    Parameters:
      `mapper` - the mapper to add

  - ### setClassname

    public void setClassname(String classname)
    Set the class name of the FileNameMapper to use.
    Parameters:
      `classname` - the name of the class

  - ### setClasspath

    public void setClasspath(Path classpath)
    Set the classpath to load the FileNameMapper through (attribute).
    Parameters:
      `classpath` - the classpath

  - ### createClasspath

    public Path createClasspath()
    Set the classpath to load the FileNameMapper through (nested element).
    Returns:
      a path object to be configured

  - ### setClasspathRef

    public void setClasspathRef(Reference ref)
    Set the classpath to load the FileNameMapper through via reference (attribute).
    Parameters:
      `ref` - the reference to the FileNameMapper

  - ### setFrom

    public void setFrom(String from)
    Set the argument to FileNameMapper.setFrom
    Parameters:
      `from` - the from attribute to pass to the FileNameMapper

  - ### setTo

    public void setTo(String to)
    Set the argument to FileNameMapper.setTo
    Parameters:
      `to` - the to attribute to pass to the FileNameMapper

  - ### setRefid

    public void setRefid(Reference r) throws BuildException
    Make this Mapper instance a reference to another Mapper.

    You must not set any other attribute if you make it a reference.

    Overrides:
      `setRefid` in class `DataType`
    Parameters:
      `r` - the reference to another mapper
    Throws:
      `BuildException` - if other attributes are set

  - ### getImplementation

    public FileNameMapper getImplementation() throws BuildException
    Returns a fully configured FileNameMapper implementation.
    Returns:
      a FileNameMapper object to be configured
    Throws:
      `BuildException` - on error

  - ### getImplementationClass

    protected Class<? extends FileNameMapper> getImplementationClass() throws ClassNotFoundException
    Gets the Class object associated with the mapper implementation.
    Returns:
      `Class`.
    Throws:
      `ClassNotFoundException` - if the class cannot be found

  - ### getRef

    @Deprecated protected Mapper getRef()
    Deprecated.
    since Ant 1.7.1 because a mapper might ref a FileNameMapper implementation directly.
    Performs the check for circular references and returns the referenced Mapper.
    Returns:
      the referenced Mapper